<template>
  <div>
    <b-form-textarea
      v-if="!loadingExtractedMetadata"
      class="rdfView mb-2"
      :disabled="true"
      :model-value="
        textRepresentation
          ? textRepresentation
          : $t('page.resource.noExtractedMetadata')
      "
    />

    <b-placeholder
      v-else
      type="input"
      size="lg"
      class="rdfView mb-2"
    ></b-placeholder>
    <b-form-select v-model="mimeType" :options="mimeTypes" />
  </div>
</template>

<script lang="ts">
import type { Dataset } from "@rdfjs/types";
import {
  getRDFContentTypes,
  serializeRDFDefinition,
} from "@/modules/resource/utils/linkedData";

export default defineComponent({
  props: {
    loadingExtractedMetadata: {
      required: true,
      type: [Boolean],
    },
    metadata: {
      required: true,
      type: [Object] as PropType<Dataset>,
    },
  },
  data() {
    return {
      mimeType: "text/turtle",
      mimeTypes: [
        { value: "application/ld+json", text: "application/ld+json" },
        { value: "text/turtle", text: "text/turtle" },
      ],
      textRepresentation: "",
    };
  },
  watch: {
    metadata() {
      this.serializeDefinition();
    },
    mimeType() {
      this.serializeDefinition();
    },
  },
  created() {
    this.getMimeTypes();
    this.serializeDefinition();
  },
  methods: {
    async getMimeTypes() {
      const contentTypes = await getRDFContentTypes();
      this.mimeTypes = [];
      for (const contentType of contentTypes) {
        this.mimeTypes.push({ value: contentType, text: contentType });
      }
    },
    async serializeDefinition() {
      this.textRepresentation = (
        await serializeRDFDefinition(this.metadata, this.mimeType)
      ).trim();
    },
  },
});
</script>

<style scoped>
.rdfView {
  min-height: 28vh;
}
</style>
